Bug 206265 - CVE-2006-4997 IP over ATM clip_mkip dereference freed pointer
Summary: CVE-2006-4997 IP over ATM clip_mkip dereference freed pointer
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel
Version: 4.0
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
: ---
Assignee: Thomas Graf
QA Contact: Brian Brock
URL:
Whiteboard: impact=moderate,reported=20060912,sou...
Keywords: Security
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2006-09-13 12:03 UTC by Marcel Holtmann
Modified: 2014-06-18 08:29 UTC (History)
4 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2006-10-05 19:20:51 UTC


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2006:0689 normal SHIPPED_LIVE Important: kernel security update 2006-10-05 04:00:00 UTC

Description Marcel Holtmann 2006-09-13 12:03:51 UTC
Reported by ADLab, Venustech info Ltd CHINA:

There is a vulnerability in function clip_mkip() in net/atm/clip.c. When
re-processing received data, a struct sk_buff pointer skb may be dereferenced
after a free operation. It will lead to a kernel panic and denying further service.
 
clip_mkip (clip.c):

502         while ((skb = skb_dequeue(&copy)) != NULL)
503                 if (!clip_devs) {
504                         atm_return(vcc,skb->truesize);
505                         kfree_skb(skb);
506                 }
507                 else {
508                         unsigned int len = skb->len;
509
510                         clip_push(vcc,skb);
511                         PRIV(skb->dev)->stats.rx_packets--;
512                         PRIV(skb->dev)->stats.rx_bytes -= len;
513                 }
 
At line 511, PRIV(skb->dev) reference skb->dev; but after call clip_push at line
510, skb may be freed.
 
clip_push (clip.c):

198 static void clip_push(struct atm_vcc *vcc,struct sk_buff *skb)
199 {

	......

234         memset(ATM_SKB(skb), 0, sizeof(struct atm_skb_data));
235         netif_rx(skb);
236 }
 
netif_rx (dev.c):

1392 int netif_rx(struct sk_buff *skb)
1393 {

	......

1428         kfree_skb(skb);	//drop skb
1429         return NET_RX_DROP;
1430 }

In netif_rx(), skb may be dropped during processing for congestion control or by
the protocol layers; the return value NET_RX_DROP is used to identify skb
pointer arg is dropped(freed).

Comment 6 Jason Baron 2006-09-26 14:46:20 UTC
committed in stream E5 build 42.0.3

Comment 8 Jason Baron 2006-09-28 15:51:10 UTC
committed in stream U5 build 42.14. A test kernel with this patch is available
from http://people.redhat.com/~jbaron/rhel4/


Comment 10 Red Hat Bugzilla 2006-10-05 19:20:51 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2006-0689.html



Note You need to log in before you can comment on or make changes to this bug.